/*
        Remake
        Copyright (C) 2008-2009 Michal Vaner (vorner@ucw.cz)

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        he Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef CACHE_CONTEXT_H
#define CACHE_CONTEXT_H

#include <stdbool.h>

struct context;
struct variable;
struct mempool_core;

void cache_context_load(int fd);
void cache_context_store(int fd);
void cache_context_resolve(void);
void cache_context_init(void);
void cache_context_restart(void);

struct context *cache_context_get(const char *filename, unsigned token_num);
void cache_context_put(struct context *context, struct mempool_core *tmp_pool);
struct variable *cache_var_check(struct variable *variable, bool cmdline);
struct context *cache_context_toplevel(void);

#endif
