/*
        Remake
        Copyright (C) 2008-2009 Michal Vaner (vorner@ucw.cz)

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        he Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef CACHE_GLOBAL_H
#define CACHE_GLOBAL_H

#include <common/stringpool.h>
#include <common/stdtrie.h>

// These two will be wiped after a cache is written
extern struct mempool_core cache_strpool_output;
extern struct mempool_core cache_pool_output;

// These will be wiped out before any cache reload
extern struct mempool_core cache_pool_input;
// Used while loading, after resolving will wipe out
extern struct mempool_core cache_pool_input_tmp;

void cache_global_init(void);
void cache_global_free_input(void);
void cache_global_free_input_tmp(void);
void cache_global_free_output(void);

// Cache read and write, throws exceptions/longjumps on errors
// TODO replace the die with the exceptions
void cache_read(int fd, void *buf, size_t count);
void cache_write(int fd, const void *buf, size_t count);

#endif
