/*
        Remake
        Copyright (C) 2008-2009 Michal Vaner (vorner@ucw.cz)

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        he Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef CACHE_LANG_H
#define CACHE_LANG_H

#include <stdbool.h>

struct lang_node;

void cache_lang_load(int fd);
void cache_lang_resolve(void);
void cache_lang_store(int fd);

void cache_lang_tree_push(struct lang_node *tree, const char *name);
struct lang_node *cache_lang_tree_get(const char *name, bool toplevel);
struct lang_node *cache_lang_node_get(struct lang_node *old_ptr);

void cache_lang_init(void);
void cache_lang_restart(void);
void cache_lang_out_free(void);

#endif
