/*
        Remake
        Copyright (C) 2008-2009 Michal Vaner (vorner@ucw.cz)

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        he Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef CACHE_STRINGS_H
#define CACHE_STRINGS_H

void cache_string_init(void);
void cache_string_restart(void);

// Data type

struct cache_string_block
{
  unsigned count;
  const char **strings;
};

// Loading

void cache_string_load(int fd);
void cache_string_clean(void);

// The strings that were read from the cache
// DO NOT CHANGE
extern struct cache_string_block cache_string_input;

// Storing

void cache_string_fill_start(void);
// Returns the index of the string
unsigned cache_string_push(const char *str);
// Makes a copy of the string
unsigned cache_string_push_dup(const char *str);
// Dump into the fd and cleans
void cache_string_store_drop(int fd);

#endif
