/*
        Remake
        Copyright (C) 2008-2009 Michal Vaner (vorner@ucw.cz)

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        he Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef COMMON_CONFIG_H
#define COMMON_CONFIG_H

#include <stdbool.h>

#include "mempool_core.h"

void config_init(int argc, char *argv[], struct mempool_core *tmp_pool);

struct strlist
{
  char *string;
  bool common:1;
  struct strlist *next;
};

#define LIST_PREFIX(X) strlist_##X
#define LIST_CONTAINER struct strlist
#define LIST_NODE struct strlist
#define LIST_HEAD next
#define LIST_NEXT next
#include "list.h"

extern const char *conf_filename;
extern const char *conf_filename_start;
extern const char *cache_filename;
extern struct strlist config_methods;
extern const char *config_targets;
extern struct strlist config_import_path_list;
extern bool nocache_flag;
extern bool config_changed_all;
extern bool config_run_all;
extern bool config_cmdvars_changed;
extern bool config_hierarchy_rebuild;
extern bool config_debug;
extern struct strlist config_defines;

extern struct mempool_core config_pool;

#endif
