/*
        Remake
        Copyright (C) 2008-2009 Michal Vaner (vorner@ucw.cz)

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        he Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef COMMON_MSG_H
#define COMMON_MSG_H

#ifdef DEBUG
#define die(format, ...) die_internal(1, "%s:%u:" format "\n", __FILE__, __LINE__, __VA_ARGS__)
#define diee(format) die_internal(1, "%s:%u:" format "\n", __FILE__, __LINE__)
#else
#define die(format, ...) die_internal(0, format "\n" , ##__VA_ARGS__)
#define diee(format) die_internal(0, format "\n")
#endif

void die_internal(int debug, const char *format, ...) __attribute__((noreturn)) __attribute__((format(printf,2,3)));
void dprintf_internal(const char *format, ...) __attribute__((format(printf,1,2)));
void gdb_catch_signals(void);
#ifdef TRACE
#include <stdio.h>
#define dprint(format, ...) dprintf_internal("%s:%u:" format "\n", __FILE__, __LINE__, __VA_ARGS__)
#define dprinte(format) dprintf_internal("%s:%u:" format "\n", __FILE__, __LINE__)
#else
#define dprint(...) do {} while(0) // No debug -> noop
#define dprinte(x) do {} while(0)
#endif

#endif
