/*
        Remake
        Copyright (C) 2008-2009 Michal Vaner (vorner@ucw.cz)

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        he Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef COMMON_FILE_H
#define COMMON_FILE_H

#include <stddef.h>
#include <stdbool.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>

typedef void (*feed_file_handler_t)(void *data, const void *buffer,
    size_t len);

void feed_file(const char *filename, void *data, feed_file_handler_t);
bool file_exists(const char *filename);

struct fileinfo
{
  unsigned filename;
  off_t size;
  time_t mod_time;
};

struct fileinfo fileinfo_get(const char *filename);

#endif
