/*
        Remake
        Copyright (C) 2008-2009 Michal Vaner (vorner@ucw.cz)

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        he Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef COMMON_MEM_H
#define COMMON_MEM_H

#include <stdlib.h>

void *xmalloc(size_t size);
void *xmalloc_zero(size_t size);
void *xrealloc(void *old, size_t size);
void xfree(void *p);

#ifdef CAN_MMAP
void *xmalloc_mmap(size_t size);
#else
#define xmalloc_mmap xmalloc
#endif

void xfree_mmap(void *p, size_t size);
void *xrealloc_mmap(void *p, size_t old_size, size_t new_size);

#endif
