/*
        Remake
        Copyright (C) 2008-2009 Michal Vaner (vorner@ucw.cz)

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        he Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "pagepool.h"
#include "memory.h"

#include <string.h>

#ifndef PAGE_POOL_SIZE
#define PAGE_POOL_SIZE 10
#endif

static void *page_pool[PAGE_POOL_SIZE];
static size_t page_pool_size = 0;

void *page_alloc(size_t size)
{
  if(size == PAGE_SIZE && page_pool_size)
    return page_pool[--page_pool_size];
  else
    return xmalloc_mmap(size);
}

void page_return(void *p, size_t size)
{
  if(size == PAGE_SIZE && page_pool_size < PAGE_POOL_SIZE)
    memset(page_pool[page_pool_size ++] = p, 0, size);
  else
    xfree_mmap(p, size);
}
