/*
        Remake
        Copyright (C) 2008-2009 Michal Vaner (vorner@ucw.cz)

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        he Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#define MEMPOOL_TYPE RECYCLER_TYPE
#define RECYCLER_POOL(X) RECYCLER_PREFIX(pool_##X)
#define MEMPOOL_PREFIX(X) RECYCLER_POOL(X)
#include "mempool.h"

#define RECYCLER_T RECYCLER_PREFIX(t)

struct RECYCLER_T
{
  struct mempool_core *pool;
  RECYCLER_TYPE *head;
};

#define RECYCLER_LIST(X) RECYCLER_PREFIX(list_##X)
#define LIST_PREFIX(X) RECYCLER_LIST(X)
#define LIST_CONTAINER struct RECYCLER_T
#define LIST_NODE RECYCLER_TYPE
#define LIST_NEXT RECYCLER_NEXT
#define LIST_HEAD head
#include "list.h"

static void RECYCLER_PREFIX(init)(struct RECYCLER_T *recycler, struct mempool_core *mempool)
{
  recycler->pool = mempool;
  RECYCLER_LIST(drop)(recycler);
}

static RECYCLER_TYPE *RECYCLER_PREFIX(get)(struct RECYCLER_T *recycler)
{
  RECYCLER_TYPE *result = RECYCLER_LIST(take_first)(recycler);
  return result ? result : RECYCLER_POOL(get)(recycler->pool);
}

static void RECYCLER_PREFIX(put)(struct RECYCLER_T *recycler,
    RECYCLER_TYPE *node)
{
  RECYCLER_LIST(prepend)(recycler, node);
}

static void RECYCLER_PREFIX(clean)(struct RECYCLER_T *recycler)
{
  RECYCLER_LIST(drop)(recycler);
}

#undef RECYCLER_T
#undef RECYCLER_PREFIX
#undef RECYCLER_TYPE
#undef RECYCLER_NEXT
#undef RECYCLER_POOL
#undef RECYCLER_LIST
