/*
        Remake
        Copyright (C) 2008-2009 Michal Vaner (vorner@ucw.cz)

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        he Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef COMMON_RESTART_H
#define COMMON_RESTART_H

#include <setjmp.h>

extern jmp_buf restart_context;

struct mempool_core;
struct restart_cleanup;

typedef void (*restart_cleanup_func)(void *data);

#define restart_init() do { \
  if(setjmp(restart_context)) \
    restart_done(); \
} while(0)
void restart_use(const char *file) __attribute__((noreturn));
void restart_done(void);
struct restart_cleanup *restart_cleanup_register(restart_cleanup_func func, void *data);
void restart_cleanup_unregister(struct restart_cleanup *cleanup);
void restart_finish(void);

#endif
