/*
        Remake
        Copyright (C) 2008-2009 Michal Vaner (vorner@ucw.cz)

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        he Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef COMMON_STRINGPOOL_H
#define COMMON_STRINGPOOL_H

#include <stddef.h>

struct mempool_core;

void strpool_init(struct mempool_core *strpool);

// Size is the length of string, without '\0' at the end
char *strpool_str_get(struct mempool_core *strpool, size_t size);
char *strpool_dup(struct mempool_core *strpool, const char *string);
char *strpool_dupn(struct mempool_core *strpool, const char *string, size_t max);
char *strpool_dupe(struct mempool_core *strpool, const char *string, size_t len);
/*
 * String concatenations. It allocates or borrows the memory from the mempool.
 * If you borrowed the memory, it is safe to pass it as the first string for further concats.
 */
char *strpool_concat(struct mempool_core *strpool, const char *first, const char *second);
char *strpool_concat_borrow(struct mempool_core *strpool, const char *first, const char *second);

void strpool_src_init(void);

extern struct mempool_core strpool;

#endif
