/*
        Remake
        Copyright (C) 2008-2009 Michal Vaner (vorner@ucw.cz)

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        he Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef INTERACT_COROUTINE_H
#define INTERACT_COROUTINE_H

#include <stdbool.h>

struct mempool_core;

typedef void (*coroutine_func)(void *data);

// Add a new routine which can cause call to external command
void coroutine_start(coroutine_func func, void *data);
// run the scheduler - will pickup children, take output of commands
// and so on.
// If block_for_children is true then it can block waiting for a child.
void coroutine_scheduler(bool block_for_child);
// Run an external command. The execution of this task will be suspended
// until the command terminates and the output is all read (if capture is
// true). The result will be the captured output (or NULL) allocated in
// mempool
char *coroutine_run_command(const char *command[], bool capture, struct mempool_core *mempool, int *result,
    const char *workdir);

void coroutine_init(void);
void coroutine_preexec(void);

#endif
