/*
        Remake
        Copyright (C) 2008-2009 Michal Vaner (vorner@ucw.cz)

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        he Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef LANG_COMPUTE_H
#define LANG_COMPUTE_H

#include <stdbool.h>

struct context;
struct lang_node;
struct mempool_core;
struct variable;

/*
 * Evaluates the expression inside this context.
 * Pass it the context and node to evaluate.
 * The mempool is to store temporary results in.
 * Specify, if this result is temporary.
 */
struct variable *expr_evaluate(struct context *context, struct lang_node *node, struct mempool_core *tmp_pool,
    bool temporary);
struct variable *expr_evaluate_ext(struct context *context, struct context *parent_context, struct lang_node *expr,
    struct mempool_core *tmp_pool, bool temporary, bool need_result, bool object_toplevel);

struct variable *variable_compute(struct context *context, const char *name, struct mempool_core *tmp_pool);

#endif
