/*
        Remake
        Copyright (C) 2008-2009 Michal Vaner (vorner@ucw.cz)

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        he Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "identifier.h"

#include <string.h>

struct ifind
{
  struct identifier *result;
  const char *name;
};

static void ifind(struct identifier *id, struct ifind *data)
{
  if(!data->result && !strcmp(data->name, id->name))
    data->result = id;
}

struct identifier *identifier_find(struct identifier_list *list,
    const char *name)
{
  struct ifind data = { .name = name };
  identifier_list_walk(list, &data, (identifier_list_walk_func) ifind);
  return data.result;
}
