/*
        Remake
        Copyright (C) 2008-2009 Michal Vaner (vorner@ucw.cz)

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        he Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef LANG_IDENTIFIER_H
#define LANG_IDENTIFIER_H

#include <stdbool.h>
#include "node.h"

struct lang_node;

struct identifier
{
  const char *name;
  struct identifier *next;
  struct identifier *symlink;
  struct node_bind_container creators;  // How to compute the variable
  bool overwritten:1;    // In the out list, there is already
                         // one direct assignment
  bool local_compute:1;
  bool global:1;         // Is this one global variable?
  bool nocache:1;        // Disable cache here
  bool exported:1;
};

struct identifier_list
{
  struct identifier *head, *tail;
};

#define LIST_PREFIX(X) identifier_list_##X
#define LIST_CONTAINER struct identifier_list
#define LIST_NODE struct identifier
#define LIST_NEXT next
#define LIST_HEAD head
#define LIST_TAIL tail
#include <common/list.h>


#define MEMPOOL_PREFIX(X) identifier_pool_##X
#define MEMPOOL_TYPE struct identifier
#include <common/mempool.h>

#define MEMPOOL_PREFIX(X) identifier_node_pool_##X
#define MEMPOOL_TYPE struct node_bind
#define MEMPOOL_HARDCODE_VARIABLE &persistent_pool
#include <common/mempool.h>

struct identifier *identifier_find(struct identifier_list *list,
    const char *name);

#endif
