/*
        Remake
        Copyright (C) 2008-2009 Michal Vaner (vorner@ucw.cz)

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        he Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "node.h"
#include "lang.h"
#include "block.h"
#include "context.h"
#include "var.h"
#include "builtin.h"

#include <common/restart.h>
#include <common/debug.h>

static void lang_restart(void *unused)
{
  dprinte("Restarting lang handlers");
  lang_node_restart();
  lang_block_restart();
  lang_var_restart();
  lang_context_restart();
}

void lang_init(struct mempool_core *tmp_pool)
{
  lang_node_init();
  lang_block_init();
  lang_var_init();
  lang_context_init(tmp_pool);
  lang_builtin_init();
  restart_cleanup_register(lang_restart, NULL);
}
