/*
        Remake
        Copyright (C) 2008-2009 Michal Vaner (vorner@ucw.cz)

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        he Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "object.h"
#include "var.h"
#include "compute.h"

#include <common/mempool_core.h>

#include <assert.h>
#include <string.h>

static int val_str_cmp(const void *v1, const void *v2)
{
  return strcmp(((struct var_value *) v1)->string, ((struct var_value *) v2)->string);
}

char *object_id_get(struct context *context, struct mempool_core *tmp_pool, char **end, size_t needed)
{
  assert(context->object);
  struct variable *deps = variable_compute(context, "DEPS", tmp_pool);
  // FIXME: This probably does not work reliably, this is just heuristic
  // Somehow build it on parameters and it's ids. Some quoting or so, and hash?
  for(size_t i = 0; i < deps->count; i ++)
  {
    assert(deps->values[i].string);
    needed += 1 + strlen(deps->values[i].string);
  }
  char *id = mempool_borrow(tmp_pool, needed), *pos = id;
  struct var_value values[deps->count];
  memcpy(values, deps->values, deps->count * sizeof *deps->values);
  qsort(values, deps->count, sizeof *deps->values, val_str_cmp);
  for(size_t i = 0; i < deps->count; i ++)
  {
    size_t len = strlen(values[i].string);
    memcpy(pos, values[i].string, len);
    pos += len;
    *pos ++ = '\n';
  }
  *end = pos;
  return id;
}
