/*
        Remake
        Copyright (C) 2008-2009 Michal Vaner (vorner@ucw.cz)

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        he Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef LANG_REFS_H
#define LANG_REFS_H

#include <common/mempool_core.h>

struct lang_node;
struct lang_ref;

struct lang_ref_list
{
  struct lang_ref *head;
};

struct lang_ref
{
  struct lang_node *node;
  struct lang_ref_list list;
};

#define LIST_PREFIX(X) lang_ref_list_##X
#define LIST_CONTAINER struct lang_ref_list
#define LIST_NODE struct lang_ref
#define LIST_HEAD head
#define LIST_NEXT list.head
#include <common/list.h>

#define MEMPOOL_TYPE struct lang_ref
#define MEMPOOL_PREFIX(X) lang_ref_pool_##X
#define MEMPOOL_HARDCODE_VARIABLE &persistent_pool
#include <common/mempool.h>

static void lang_ref_prepend(struct lang_ref_list *where, struct lang_node *what)
{
  struct lang_ref *ref = lang_ref_pool_get();
  ref->node = what;
  lang_ref_list_prepend(where, ref);
}

#endif
