/*
        Remake
        Copyright (C) 2008-2009 Michal Vaner (vorner@ucw.cz)

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        he Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef LANG_VAR_DEP_H
#define LANG_VAR_DEP_H

#include "var.h"

struct var_dep
{
  const char *filename;
  struct var_dep *next;
};

#define LIST_PREFIX(X) dep_list_##X
#define LIST_CONTAINER struct var_dep_list
#define LIST_NODE struct var_dep
#define LIST_NEXT next
#define LIST_HEAD head
#define LIST_TAIL tail
#include <common/list.h>

struct var_dep_chain
{
  struct var_dep_list *head, *tail;
};

#define LIST_PREFIX(X) dep_chain_##X
#define LIST_CONTAINER struct var_dep_chain
#define LIST_NODE struct var_dep_list
#define LIST_NEXT next
#define LIST_HEAD head
#define LIST_TAIL tail
#include <common/list.h>

#define LIST_PREFIX(X) dep_filter_##X
#define LIST_CONTAINER struct var_dep_chain
#define LIST_NODE struct var_dep_list
#define LIST_NEXT next_filter
#define LIST_HEAD head
#define LIST_TAIL tail
#include <common/list.h>

extern struct var_dep_chain var_dep_single, var_dep_merged;

#endif
