/*
        Remake
        Copyright (C) 2008-2009 Michal Vaner (vorner@ucw.cz)

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        he Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "parser.h"
#include "tree.h"
#include "token.h"
#include "shape.h"

#include <common/file.h>
#include <common/restart.h>

#include <stdio.h>

static void parser_restart(void *unused)
{
}

void parser_init(void)
{
  restart_cleanup_register(parser_restart, NULL);
}

static void tree_error(void *data, const char *message, int fatal)
{
  (void) data;
  (void) fatal;
  fputs(message, stderr);
}

static void token_error(void *data, const char *message)
{
  (void) data;
  fputs(message, stderr);
}

struct lang_node *parse_file(const char *file)
{
  struct treeb_state *treeb = treeb_create(NULL, tree_error, file);
  struct token_state *tokens = token_create(treeb, token_error, (token_handler_t) treeb_insert);
  feed_file(file, tokens, (feed_file_handler_t) token_process);
  token_destroy(tokens);
  return tree_postprocess(treeb_destroy(treeb));
}
