/*
        Remake
        Copyright (C) 2008-2009 Michal Vaner (vorner@ucw.cz)

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        he Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef PARSER_TREE_H
#define PARSER_TREE_H

#include "token.h"

struct treeb_state;
struct lang_node;

typedef void (*treeb_error_handler_t)(void *data, const char *msg, int fatal);
struct treeb_state *treeb_create(void *data, treeb_error_handler_t error_handler, const char *filename);
void treeb_insert(struct treeb_state *state, const char *token, size_t len, enum token_type type, unsigned line);
struct lang_node *treeb_destroy(struct treeb_state *state);

#endif
