/*
        Remake
        Copyright (C) 2008-2009 Michal Vaner (vorner@ucw.cz)

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        he Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef PLAN_POBJECT_H
#define PLAN_POBJECT_H

#include <stdbool.h>

struct var_value;
struct pobject;

struct dep_bind
{
  struct dep_bind *dep_next, *dep_prev, *owner_next, *owner_prev;
  struct pobject *owner, *dep;
};

struct pobject
{
  struct var_value *object;
  struct pobject *next, *prev;
  struct dep_bind *dep_head, *dep_tail, *owner_head, *owner_tail;
  bool done:1;
  bool scheduling:1;
  bool scheduled:1;
  bool changed_deps:1;
};

struct pobject_list
{
  struct pobject *head, *tail;
};

#define LIST_PREFIX(X) dep_list_##X
#define LIST_NODE struct dep_bind
#define LIST_CONTAINER struct pobject
#define LIST_HEAD dep_head
#define LIST_TAIL dep_tail
#define LIST_NEXT dep_next
#define LIST_PREV dep_prev
#include <common/list.h>

#define LIST_PREFIX(X) owner_list_##X
#define LIST_NODE struct dep_bind
#define LIST_CONTAINER struct pobject
#define LIST_HEAD owner_head
#define LIST_TAIL owner_tail
#define LIST_NEXT owner_next
#define LIST_PREV owner_prev
#include <common/list.h>

#define LIST_PREFIX(X) pobject_list_##X
#define LIST_NODE struct pobject
#define LIST_CONTAINER struct pobject_list
#define LIST_HEAD head
#define LIST_TAIL tail
#define LIST_NEXT next
#define LIST_PREV prev
#include <common/list.h>

void pobject_init(void);

#endif
